#!/usr/bin/env python
# -*- coding: utf-8 -*-
# @Time    : 17-4-14
# @Author  : JCai
# @desc    :


from __future__ import absolute_import, unicode_literals

import django
import os
from celery import Celery
from celery.schedules import crontab
from django.conf import settings
# set the default Django settings module for the 'celery' program.
from datetime import timedelta

os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'EBayClub.settings')
os.environ['DJANGO_SETTINGS_MODULE'] = 'EBayClub.settings'
django.setup()

# brokers = 'redis://127.0.0.1:6379/5'
# backend = 'redis://127.0.0.1:6379/6'
# app = Celery('tasks', broker=broker, backend=backend)
app = Celery('EBayClub')
app.conf.update(
    # 使用RabbitMQ作为消息代理
    BROKER_URL='redis://127.0.0.1:6379/1',
    # 使用Redis作为结果存储
    # CELERY_RESULT_BACKEND='redis://127.0.0.1:6379/1',
    # 使用Msgpack作为有效载荷序列化方案
    # CELERY_TASK_SERIALIZER='msgpack',
    # 使用可读性好的Json作为结果最终存储
    CELERY_RESULT_SERIALIZER='json',
    # 并发worker数
    CELERYD_CONCURRENCY=10,
    # 设置任务过期时间为1天
    CELERY_TASK_RESULT_EXPIRES=60 * 60 * 6,
    # 指定接受的内容类型
    CELERY_ACCEPT_COUNT=['json'],
    # CELERY_ACCEPT_COUNT=['json', 'msgpack'],
    # 子进程长时间处理任务可能内存泄漏,设置执行多少任务就死掉重生
    CELERYD_MAX_TASKS_PER_CHILD=40,

    CELERYBEAT_SCHEDULE={
        # 'scan_task_robot_status': {
        #     'task': 'order.tasks.scan_task_robot_status',
        #     'schedule': timedelta(seconds=2),
        #     # 'schedule': crontab(minute='*/1'),
        #     'args': ()
        # },
        # 'generate_daily_robot_task': {
        #     'task': 'order.tasks.generate_daily_robot_task',
        #     'schedule': timedelta(seconds=10),
        #     # 'schedule': crontab(minute='*/1'),
        #     'args': ()
        # },
        # 'order_task_generate': {
        #     'task': 'order.tasks.order_task_generate',
        #     'schedule': timedelta(seconds=15*60),
        #     # 'schedule': crontab(minute='*/1'),
        #     'args': ()
        # }
    },
)
# Using a string here means the worker doesn't have to serialize
# the configuration object to child processes.
# - namespace='CELERY' means all celery-related configuration keys
#   should have a `CELERY_` prefix.
# app.config_from_object('django.conf:settings', namespace='CELERY')
app.config_from_object('django.conf:settings')
app.autodiscover_tasks(lambda: settings.INSTALLED_APPS)

# Load task modules from all registered Django app configs.
# app.autodiscover_tasks()


@app.task(bind=True)
def debug_task(self):
    print 'dddd'
    # print('Request: {0!r}'.format(self.request))

# celery -A EBayClub worker -l info --beat

# nohup celery -A EBayClub worker -l info --beat > ../log_ebay/celery.out 2>&1 &
